#include "CFChattersWin.H"

#include "Logger.H"
extern Logger logger;

CFChattersWin::CFChattersWin(int wdth, int hght, bool brdr, bool shdw):
		Window(wdth,hght,brdr, shdw) {
	string
		wname;
	_rebld=true;
	_wtitle="Chatter's Box";
	_rlistwid=new TextArea(wdth-4,hght-2,50);	//BEM: changed 35 to 50
	(*_rlistwid).style(_stile);
	wname="Room List";
	Window::add(wname,_rlistwid,2,1);
}

CFChattersWin::~CFChattersWin() {
	delete (_rlistwid);
}

widstat CFChattersWin::input(Char inp) {
	return (*_rlistwid).input(inp);
}

widstat CFChattersWin::style(Char stile) {
	_stile=stile;
	(*_rlistwid).style(_stile);
	_rebld=true;
	return (ws_accepted);
}

int CFChattersWin::add(const StrList &ul, const StrList &ig) {
	_roomlist.clear();
	for (unsigned int i=0; i < ul.size(); i++) {
		userstatus
			tmp;
		tmp.name=ul[i];;
		tmp.isIggy=ig.inlist(tmp.name);
		_roomlist.insert(tmp);
	}
	makeGrid();
	return 0;
}

int CFChattersWin::add(const string &user, bool iggy, bool away) {
	userstatus
		tmp;

	tmp.name=user;
	tmp.isAway=away;
	tmp.isIggy=iggy;
	_roomlist.erase(tmp);
	_roomlist.insert(tmp);
	makeGrid();
	return 0;
}

int CFChattersWin::remove(const string &user) {
	userstatus
		tmp;

	tmp.name=user;
	_roomlist.erase(tmp);
	makeGrid();
	return 0;
}

StrList CFChattersWin::getList() {
	set<userstatus,userstatus>::const_iterator
		inc;
	StrList
		rlist;

	for (inc=_roomlist.begin(); inc != _roomlist.end(); inc++) {
		rlist.add((*inc).name);
	}
	return (rlist);
}

void CFChattersWin::makeGrid() {
	set<userstatus,userstatus>::const_iterator
		inc;

	(*_rlistwid).clear();
	for (inc=_roomlist.begin(); inc != _roomlist.end(); inc++) {
		Text
			txt;
		if ((*inc).isIggy) {
			Char c;
			c.setFore(cc_black);
			txt.style(c);
		}
		else if ((*inc).isAway) {
			Char c;
			c.setFore(cc_cyan);
			txt.style(c);
		}
		txt.setText((*inc).name);
		txt.chop((*_rlistwid).width()-1);
		(*_rlistwid)+=txt;
	}
	_rebld=true;
}
